FarPointSpread              CLASS,Type,MODULE('FarPointSpread.clw'),LINK('FarPointSpread.clw',_FPSLinkMode_),DLL(_FPSDllMode_)

              ! Properties -----------------------------------------------------------------------
W                          &Window
cOLE                       Short
cPreviewOLE                Short
hWnd                       LONG
LogFileName                STRING(90)  !
StrCl                      &StrClType
StdComCl                   &StdComClType
RegisterControl            LONG(TRUE)

              ! Methods -------------------------------------------------------------------------
Init                       Procedure(Window W,Short OLEControl),VIRTUAL,Proc
InitPreview                Procedure(Window W,Short OLEControl),VIRTUAL,Proc
Kill                       Procedure(),VIRTUAL,Proc

!!!!!!!!!!!!!!!!!!   A    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

ActiveCellHighlightStyle  PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
ActiveCol                 PROCEDURE(),LONG,VIRTUAL                                 !
ActiveRow                 PROCEDURE(),LONG,VIRTUAL
ActiveSheet               PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AllowCellOverflow         PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AllowColMove              PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AllowDragDrop             PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AllowEditOverflow         PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AllowMultiBlocks          PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AllowRowMove              PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AllowUserFormulas         PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AllowUserZoom             PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
Appearance                PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
AppearanceStyle            PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
ArrowsExitEditMode        PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
AutoClipboard             PROCEDURE(<LONG value>),SHORT,VIRTUAL,PROC
AutoCalc                  PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
AutoSize                  PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!   B    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

BackColor                 PROCEDURE(<LONG color>),LONG,VIRTUAL,PROC
BackColorStyle            PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
BlockMode                 PROCEDURE(<BYTE setting>),BYTE,VIRTUAL,PROC
BorderStyle               PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
ButtonDrawMode            PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC

!!!!!!!!!!!!!!!!    C    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

CellNote                  PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
CellNoteIndicator         PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
CellNoteIndicatorShape    PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
CellTag                   PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
CellType                  PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
ChangeMade                PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
Clip                      PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
ClipboardOptions          PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
ClipValue                 PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
Col                       PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
Col2                      PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
ColHeaderRows             PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
ColHeadersAutoText        PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
ColHeadersAutoTextIndex   PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
ColHeadersShow            PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ColHeadersUserSortIndex   PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
ColHidden                 PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ColID                     PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
ColMerge                  PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
ColPageBreak              PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ColsFrozen                PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
ColUserSortIndicator      PROCEDURE(LONG lCol, <LONG value>),LONG,VIRTUAL,PROC
ColWidth                  PROCEDURE(LONG lCol, <REAL value>),REAL,VIRTUAL,PROC
!CursorIcon                PROCEDURE(<>),,VIRTUAL,PROC
CursorStyle               PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
CursorType                PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!     D  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

DataChanged               PROCEDURE(),SHORT,VIRTUAL,PROC
DataColCnt                PROCEDURE(),LONG,VIRTUAL  
DataField                 PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
DataFillEvent             PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
DataRowCnt                PROCEDURE(),LONG,VIRTUAL,PROC
DAutoCellTypes            PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
DAutoFill                 PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
DAutoHeadings             PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
DAutoSave                 PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
DAutoSizeCols             PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
DInformActiveRowChange    PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!    E  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

EditEnterAction           PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
EditMode                  PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
EditModePermanent         PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
EditModeReplace           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
EnhanceStaticCells        PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
EventEnabled              PROCEDURE(LONG event,<SHORT value>),SHORT,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!   F   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

FontBold                  PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
FontItalic                PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
FontName                  PROCEDURE(<STRING fontname>),STRING,VIRTUAL,PROC
FontSize                  PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
FontStrikethru            PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
FontUnderline             PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
ForeColor                 PROCEDURE(<LONG color>),LONG,VIRTUAL,PROC
Formula                   PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
FormulaSync               PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!   G   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

GrayAreaBackColor         PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
GrayAreaColor             PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
GrayAreaMarginH           PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
GrayAreaMarginType        PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
GrayAreaMarginV           PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
GridColor                 PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
GridShowHoriz             PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
GridShowVert              PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
GridSolid                 PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!   H   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                           
hDCPrinter                PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
hWndSpread                PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
HighlightHeaders          PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
HighlightAlphaBlendColor  PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
!!!!!!!!!!!!!!!!!!!   I   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

IsBlockSelected           PROCEDURE(),LONG,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!   L   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

LeftCol                   PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
Lock                      PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
LockBackColor             PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
LockForeColor             PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!   M   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                           
MaxCols                   PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
MaxRows                   PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
MaxTextCellHeight         PROCEDURE(),REAL,VIRTUAL,PROC
MaxTextCellWidth          PROCEDURE(),REAL,VIRTUAL,PROC
MaxTextColWidth           PROCEDURE(<LONG ICol>),REAL,VIRTUAL,PROC
MaxTextRowHeight          PROCEDURE(<LONG IRow>),REAL,VIRTUAL,PROC
MoveActiveOnFocus         PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC

LoadPicture               PROCEDURE(STRING PicFileName, <LONG PicType>),VIRTUAL


NoBeep                    PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
NoBorder                  PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC


OperationMode             PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC


PageBorderColor           PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
PageBorderWidth           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PageCurrent               PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
PageGutterH               PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
PageGutterV               PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
PageMultiCntH             PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PageMultiCntV             PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PagePercentageActual      PROCEDURE(),SHORT,VIRTUAL
PageShadowColor           PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
PageShadowWidth           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PagesPerScreen            PROCEDURE(),SHORT,VIRTUAL
PageViewPercentage        PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PageViewType              PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
PrintAbortMsg             PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
PrintBestFitPagesTall     PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PrintBestFitPagesWide     PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PrintBorder               PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintCenterOnPageH        PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintCenterOnPageV        PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintColHeaders           PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintColor                PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintFirstPageNumber      PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
PrintFooter               PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
PrintGrid                 PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintHeader               PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
PrintJobName              PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
PrintMarginBottom         PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
PrintMarginLeft           PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
PrintMarginRight          PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
PrintMarginTop            PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
!follow settings are skipped so far
!            short PrintPageEnd;
!            short PrintPageStart;
PrintNextPageBreakCol     PROCEDURE(),LONG,VIRTUAL
PrintNextPageBreakRow     PROCEDURE(),LONG,VIRTUAL
PrintOrientation          PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
PrintPageCount            PROCEDURE(),LONG,VIRTUAL
PrintPageEnd              PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PrintPageStart            PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
PrintPageOrder            PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
PrintRowHeaders           PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintScalingMethod        PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
PrintShadows              PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintType                 PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintUseDataMax           PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
PrintZoomFactor           PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
ProcessTab                PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
Protect                   PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC


Redraw                    PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
RetainSelBlock            PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
RemoveCellSpan            PROCEDURE(LONG lCol, LONG lRow),VIRTUAL
Row                       PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
Row2                      PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
RowHeaderCols             PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
RowHeadersAutoText        PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
RowHeadersAutoTextIndex   PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
RowHeadersShow            PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
RowHeight                 PROCEDURE(LONG IRow,<REAL value>),REAL,VIRTUAL,PROC
RowHidden                 PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
RowMerge                  PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
RowPageBreak              PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
RowsFrozen                PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC


ScriptEnhanced            PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ScrollBarExtMode          PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ScrollBarH                PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
ScrollBarHColor           PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
ScrollBarHeight           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ScrollBarMaxAlign         PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ScrollBars                PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
ScrollBarShowMax          PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ScrollBarTrack            PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
ScrollBarV                PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
ScrollBarVColor           PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
ScrollBarWidth            PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ScrollIncH                PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
ScrollIncV                PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
SelBackColor              PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
SelBlockCol               PROCEDURE(),LONG,VIRTUAL,PROC
SelBlockCol2              PROCEDURE(),LONG,VIRTUAL,PROC
SelBlockRow               PROCEDURE(),LONG,VIRTUAL,PROC
SelBlockRow2              PROCEDURE(),LONG,VIRTUAL,PROC
SelectBlockOptions        PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
SelectionCount            PROCEDURE(),LONG,VIRTUAL,PROC
SelForeColor              PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
SelLength                 PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
SelModeIndex              PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
SelModeSelected           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
SelStart                  PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
SelText                   PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
ShadowColor               PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
ShadowDark                PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
ShadowText                PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
Sheet                     PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
SheetCount                PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
SheetName                 PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
SheetSendingEvent         PROCEDURE(),LONG,VIRTUAL
SheetVisible              PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
ShowScrollTips            PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
SortKey                   PROCEDURE(SHORT index, <LONG value>),LONG,VIRTUAL,PROC
SortKeyOrder              PROCEDURE(SHORT index, <LONG setting>),LONG,VIRTUAL,PROC
StartingColNumber         PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
StartingRowNumber         PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

TabStripLeftSheet        PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TabStripPolicy           PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TabStripRatio            PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
Text_                     PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TextTip                  PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TextTipDelay             PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
TopRow                   PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
TwoDigitYearMa           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeButtonAlign          PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeButtonBorderColor    PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
TypeButtonColor          PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
TypeButtonDarkColor      PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
TypeButtonLightColor     PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
!TypeButtonPicture        PROCEDURE(<>),,VIRTUAL,PROC
!TypeButtonPictureDown    PROCEDURE(<>),,VIRTUAL,PROC
TypeButtonShadowSize     PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeButtonText           PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeButtonTextColor      PROCEDURE(<ULONG color>),ULONG,VIRTUAL,PROC
TypeButtonType           PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeCheckCenter           PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
!TypeCheckPicture
TypeCheckText            PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeCheckTextAlign       PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeCheckType            PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeComboBoxAutoSearch   PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeComboBoxCount        PROCEDURE(),SHORT,VIRTUAL
TypeComboBoxCurSel       PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeComboBoxEditable     PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeComboBoxhWnd         PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
TypeComboBoxIndex        PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeComboBoxList         PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeComboBoxMaxDrop      PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeComboBoxString       PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeComboBoxWidth        PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeCurrencyDecimal      PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeCurrencyDecPlaces    PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeCurrencyLeadingZero  PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeCurrencyMax          PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypeCurrencyMin          PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypeCurrencyNegStyle     PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeCurrencyPosStyle     PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeCurrencySeparator    PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeCurrencyShowSep      PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeCurrencyShowSymbol   PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeCurrencySymbol       PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeDateCentury           PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeDateFormat            PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeDateMax              PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeDateMin              PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeDateSeparator        PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeEditCharCase         PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeEditCharSet          PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeEditLen              PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeEditMultiLine        PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeEditPassword         PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeEllipses             PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeHAlign                PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeMaxEditLen           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeNegRed               PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeNumberDecimal        PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeNumberDecPlaces      PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeNumberLeadingZero    PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeNumberMax            PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypeNumberMin            PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypeNumberNegStyle       PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeNumberSeparator      PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeNumberShowSep        PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeOwnerDrawStyle       PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
TypePercentDecimal       PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypePercentDecPlaces     PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypePercentLeadingZero   PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypePercentMax           PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypePercentMin           PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypePercentNegStyle      PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypePicDefaultText       PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypePicMask               PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypePictCenter            PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypePictMaintainScale     PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
!TypePictPicture 
TypePictStretch           PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeScientificDecimal    PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeScientificDecPlaces  PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeScientificMax        PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypeScientificMin        PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypeSpin                 PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeSpinInc              PROCEDURE(<REAL value>),REAL,VIRTUAL,PROC
TypeSpinWrap             PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeTextOrient           PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
TypeTextPrefix           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeTextShadow           PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeTextShadowIn         PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeTextWordWrap         PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeTime24Hour            PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeTimeMax              PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeTimeMin              PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
TypeTimeSeconds           PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
TypeTimeSeparator        PROCEDURE(<SHORT value>),SHORT,VIRTUAL,PROC
TypeVAlign               PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
UnitType                 PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
UserColAction             PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
UserResize               PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
UserResizeCol            PROCEDURE(<LONG setting>),LONG,VIRTUAL,PROC
UserResizeRow            PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
UseVisualStyles          PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Value                     PROCEDURE(<STRING text>),STRING,VIRTUAL,PROC
VirtualCurRowCount       PROCEDURE(),LONG,VIRTUAL,PROC
VirtualCurTop            PROCEDURE(),LONG,VIRTUAL,PROC
VirtualMaxRows           PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
VirtualMode              PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
VirtualOverlap           PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
VirtualRows              PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
VirtualScrollBuffer      PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
VisibleCols               PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
VisibleRows               PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
VScrollSpecial           PROCEDURE(<SHORT setting>),SHORT,VIRTUAL,PROC
VScrollSpecialType       PROCEDURE(<LONG value>),LONG,VIRTUAL
ZoomState                PROCEDURE(<LONG setting>),LONG,VIRTUAL

                           !FarPoint methods
AddCellSpan               PROCEDURE(LONG lCol, LONG lRow, LONG lNumCols, LONG lNumRows),SHORT,VIRTUAL,PROC
AddCustomFunction         PROCEDURE(STRING FunctionName, SHORT ParameterCnt),LONG,VIRTUAL,PROC
AddSelection              PROCEDURE(LONG lCol, LONG lRow, LONG lCol2, LONG lRow2),VIRTUAL
ClearRange                PROCEDURE(LONG lCol, LONG lRow, LONG lCol2, LONG lRow2, SHORT DataOnly=0),VIRTUAL
ClearSelection            PROCEDURE(),VIRTUAL,PROC
ClipboardCopy             PROCEDURE(),VIRTUAL,PROC
ClipboardCut              PROCEDURE(),VIRTUAL,PROC
ClipboardPaste            PROCEDURE(),VIRTUAL,PROC
ColLetterToNumber         PROCEDURE(STRING HeaderLetter),LONG,VIRTUAL
ColNumberToLetter         PROCEDURE(LONG HeaderNumber),STRING,VIRTUAL
CopyRange                 PROCEDURE(LONG lCol, LONG lRow, LONG lCol2, LONG lRow2, LONG lColDest, LONG lRowDest),VIRTUAL
CopyRowRange              PROCEDURE(LONG lRow, LONG lRow2, LONG lRowDest),VIRTUAL
CopyColRange              PROCEDURE(LONG lCol, LONG lCol2, LONG lColDest),VIRTUAL
DeleteCols                PROCEDURE(LONG lCol, LONG lNumCols),VIRTUAL
DeleteRows                PROCEDURE(LONG lRow, LONG lNumRows),VIRTUAL
DeleteSheets              PROCEDURE(LONG SheetIndex, LONG SheetCnt),LONG,VIRTUAL,PROC

ExportExcelBook           PROCEDURE(STRING FileName, STRING LogFileName),SHORT,VIRTUAL,PROC
ExportExcelBookEx         PROCEDURE(STRING FileName, STRING LogFileName, SHORT Flags),SHORT,VIRTUAL,PROC
ExportRangeToHTML         PROCEDURE(LONG Col, LONG Row, LONG Col2, LONG Row2, STRING FileName, BOOL AppendFlag, STRING LogFile),SHORT,VIRTUAL,PROC
ExportRangeToTextFile     PROCEDURE(LONG Col, LONG Row, LONG Col2, LONG Row2, STRING FileName, STRING CellDelim, STRING ColDelim, STRING RowDelim, |
                          LONG Flags, STRING LogFile),SHORT,VIRTUAL,PROC
ExportRangeToTextFileU    PROCEDURE(LONG Col, LONG Row, LONG Col2, LONG Row2, STRING FileName, STRING CellDelim, STRING ColDelim, STRING RowDelim, |
                          LONG Flags, STRING LogFile),SHORT,VIRTUAL,PROC
ExportRangeToXML          PROCEDURE(LONG Col, LONG Row, LONG Col2, LONG Row2, STRING FileName, STRING Root, STRING Collection, LONG Flags, STRING LogFile),SHORT,VIRTUAL,PROC
ExportToExcel             PROCEDURE(STRING FileName, STRING SheetName, STRING LogFileName),SHORT,VIRTUAL,PROC
ExportToExcelEx           PROCEDURE(STRING FileName, STRING SheetName, STRING LogFileName, SHORT Flags),SHORT,VIRTUAL,PROC
ExportToHTML              PROCEDURE(STRING FileName, BOOL AppendFlag),SHORT,VIRTUAL,PROC
ExportToTextFile          PROCEDURE(STRING FileName, STRING CellDelim, STRING ColDelim, STRING RowDelim, LONG Flags, STRING LogFile),SHORT,VIRTUAL,PROC
ExportToTextFileU         PROCEDURE(STRING FileName, STRING CellDelim, STRING ColDelim, STRING RowDelim, LONG Flags, STRING LogFile),SHORT,VIRTUAL,PROC
ExportToXML               PROCEDURE(STRING FileName, STRING Root, STRING Collection, LONG Flags, STRING LogFile),SHORT,VIRTUAL,PROC
GetActionKey              PROCEDURE(LONG Action, *LONG fShift, *LONG fCtrl, *SHORT pKey),SHORT,VIRTUAL,PROC
GetBottomRightCell        PROCEDURE(*LONG Col, *LONG Row),VIRTUAL,PROC
GetCellBorder             PROCEDURE(LONG lCol, LONG lRow, *LONG BorderType, *LONG BorderStyle, *LONG BorderColor),VIRTUAL
GetCellSpan               PROCEDURE(LONG lCol, LONG lRow , *LONG pvColAnchor, *LONG pvRowAnchor, *LONG pvNumCols, *LONG pvNumRows),SHORT,VIRTUAL,PROC
GetColFromID              PROCEDURE(STRING ColID),LONG,PROC,VIRTUAL
GetRefStyle               PROCEDURE(),LONG,VIRTUAL
ImportExcelBook           PROCEDURE(STRING FileName, <STRING LogFileName>),LONG,PROC,VIRTUAL
InsertCols                PROCEDURE(LONG lCol, LONG lNumCols),VIRTUAL
InsertRows                PROCEDURE(LONG lRow, LONG lNumRows),VIRTUAL
InsertSheets              PROCEDURE(LONG SheetIndex, LONG SheetCnt),LONG,VIRTUAL,PROC
IsExcelFile               PROCEDURE(STRING FileName),SHORT,VIRTUAL
LoadBlockFromBuffer       PROCEDURE(LONG hWnd, LONG col, LONG row, LONG col2, LONG row2, LONG hBuffer, LONG lpBufferLen),LONG,VIRTUAL
LoadFromFile              PROCEDURE(STRING FileName),SHORT,VIRTUAL,PROC
LoadTabFile               PROCEDURE(STRING FileName),SHORT,VIRTUAL,PROC
LoadTextFile              PROCEDURE(STRING FileName, STRING CellDelim, STRING ColDelim, STRING RowDelim, LONG LoadTextFileConstants, STRING LogFile),SHORT,VIRTUAL,PROC

PrintSheet                PROCEDURE(LONG Flags=0 ),VIRTUAL
ReCalc                    PROCEDURE(),VIRTUAL
ReCalcCell                PROCEDURE(LONG Col, LONG Row),VIRTUAL
Refresh                   PROCEDURE(),VIRTUAL
Reset                     PROCEDURE(),VIRTUAL
SaveBlockToBuffer         PROCEDURE(LONG hWnd, LONG col, LONG row, LONG col2, LONG row2, *LONG lpBufferLen, LONG fDataOnly=FALSE),LONG,VIRTUAL
SaveTabFile               PROCEDURE(STRING FileName),SHORT,VIRTUAL,PROC
SaveTabFileU              PROCEDURE(STRING FileName),SHORT,VIRTUAL,PROC
SaveToFile                PROCEDURE(STRING FileName,BOOL DataOnly),SHORT,VIRTUAL,PROC
SearchCol                 PROCEDURE(LONG lCol, LONG lRowStart, LONG lRowEnd, STRING Text, LONG SearchFlags),LONG,VIRTUAL
SearchRow                 PROCEDURE(LONG lRow, LONG lColStart, LONG lColEnd, STRING Text, LONG SearchFlags),LONG,VIRTUAL
SetActiveCell             PROCEDURE(LONG lCol, LONG lRow),VIRTUAL
SetCellBorder             PROCEDURE(LONG lCol, LONG lRow, LONG lCol2, LONG lRow2, LONG nIndex, LONG crColor, LONG nStyle),VIRTUAL
SetEnhancedColumnHeaderColors PROCEDURE(long clrSelectedHoverUpperColor, long clrSelectedHoverLowerColor, long clrSelectedUpperColor, |
                                        long clrSelectedLowerColor,long clrHoverUpperColor, long clrHoverLowerColor,long clrUpperColor, |
                                        long clrLowerColor,long clrSelectedBorderColor, long clrBorderColor),LONG,VIRTUAL
SetEnhancedCornerColors   PROCEDURE(LONG BackColor, LONG hoverBackColor, LONG triangleColor, LONG triangleHoverColor, LONG triangleBorderColor, |
                                    LONG triangleHoverBorderColor),LONG,VIRTUAL
SetEnhancedScrollbarColors PROCEDURE(LONG clrTrackColor, LONG clrArrowColor, LONG clrUpperNormalStartColor, |
                                     LONG clrUpperNormalEndColor, LONG clrLowerNormalStartColor, LONG clrLowerNormalEndColor, |
                                     LONG clrUpperPushedStartColor, LONG clrUpperPushedEndColor, LONG clrLowerPushedStartColor, |
                                     LONG clrLowerPushedEndColor, LONG clrUpperHoverStartColor, LONG clrUpperHoverEndColor, |
                                     LONG clrLowerHoverStartColor,LONG clrLowerHoverEndColor, LONG clrHoverButtonBorderColor, |
                                     LONG clrButtonBorderColor),LONG,VIRTUAL
SetEnhancedSheetTabColors PROCEDURE(LONG clrNormalUpperStartColor, LONG clrNormalUpperEndColor, LONG clrNormalLowerStartColor, |
                                    LONG clrNormalLowerEndColor,LONG clrHoverUpperStartColor, LONG clrHoverUpperEndColor,|
                                    LONG clrHoverLowerStartColor, LONG clrHoverLowerEndColor,LONG clrTabOuterBorderColor, |
                                    LONG clrTabInnerBorderColor,LONG clrButtonUpperNormalStartColor,LONG clrButtonUpperNormalEndColor,|
                                    LONG clrButtonLowerNormalStartColor,LONG clrButtonLowerNormalEndColor,LONG clrButtonUpperHoverStartColor,|
                                    LONG clrButtonUpperHoverEndColor,LONG clrButtonLowerHoverStartColor,LONG clrButtonLowerHoverEndColor,|
                                    LONG clrButtonUpperPushedStartColor,LONG clrButtonUpperPushedEndColor,LONG clrButtonLowerPushedStartColor,|
                                    LONG clrButtonLowerPushedEndColor,LONG clrArrowColor,LONG clrBackColorStartColor,LONG clrBackColorEndColor,|
                                    LONG clrSplitBoxStartColor,LONG clrSplitBoxEndColor,LONG clrSheetTabForeColor,LONG clrSheetTabActiveForeColor),LONG,VIRTUAL

SetRefStyle               PROCEDURE(LONG RefStyle),VIRTUAL
SetSelection              PROCEDURE(LONG lCol, LONG lRow, LONG lCol2, LONG lRow2),VIRTUAL

ShowCell                  PROCEDURE(LONG lCol, LONG lRow, LONG PositionConstants),VIRTUAL
Sort                      PROCEDURE(LONG lCol, LONG lRow, LONG lCol2, LONG lRow2, LONG SortByConstants),LONG,VIRTUAL
!Preview Calls !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PreviewhWndSpread         PROCEDURE(<LONG value>),LONG,VIRTUAL,PROC
 END



! --->>> COM
hresult                     equate(LONG) !Com error code return type
!parameters for invoke

dispparms           group           !used to pass parameters to a Idispatch invoke method
lparrOfargs           LONG
lpdispofargs          LONG  !0
NumArgs               LONG
numNamedArgs          LONG  !0
                    end
!variant group def
VariantType         GROUP,TYPE     !variant structure
vt                    USHORT
wReserved1            USHORT
wReserved2            USHORT
wReserved3            USHORT
Value                 LONG
extrapad              ULONG
                    END
 
 INCLUDE('FarPointSpread.equ'),once